/* $Id: Server.h,v 1.8 2002/04/12 23:04:01 nekeme Exp $
** Ark - Libraries, Tools & Programs for MMORPG developpements.
** Copyright (C) 1999-2000 The Contributors of the ArkRPG Project
** Please see the file "AUTHORS" for a list of contributors
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef SERVER_SERVER_H
#define SERVER_SERVER_H

#include <Engine/Engine.h>
#include <Server/Network.h>

#include <stdio.h>
#include <map>

namespace Server
{
   class Server
   {
	 Ark::Engine *m_Engine;
	 Ark::Cache m_Cache;
	 Network *m_Network;

	 // Time stuff
	 scalar m_SleepTime;

      public:
	 Server ();
	 ~Server ();

	 int Loop ();
	 Ark::Engine *GetEngine() {return m_Engine;}
   };
   
   Server *GetServer ();
   bool IsShutdown ();
}

#endif
